;; * add-to-list-x
(defun add-to-list-x (LIST-VAR &rest REST)
  (mapc (lambda(ELEMENT) (add-to-list LIST-VAR ELEMENT)) REST))

;; init.el/load-path
;; (add-to-list-x 'load-path
;;                init-dir
;;                (expand-file-name "_misc/" init-dir)
;;                (expand-file-name "_color-theme/" init-dir)
;; )

(defun add-to-list-l (LIST-VAR LIST)
  (apply 'add-to-list-x LIST-VAR LIST))

(defun add-to-list-p (LIST-VAR &optional BASE &rest REST)
  (mapc (lambda(ELEMENT) (add-to-list LIST-VAR (expand-file-name ELEMENT BASE))) REST))

;; * require-x
(defun require-x (action lst)
  (mapcar (lambda(ext) (funcall action ext)) lst))

;; * define-key-s
(defun define-key-s (keymap key-defs)
  "(define-key-s map '(key def key def ...))"
  (let ((map (cond
              ((eq keymap 0) (current-global-map))
              ((eq keymap 1) (current-local-map))
              (t keymap))))
    (while (cadr key-defs)
      (let* ((key (pop key-defs))
             (def (pop key-defs)))
        (define-key
          map
          (eval `(kbd ,key))
          def)
        ))))

(defun def-key-s (keymap &rest key-defs)
  "(def-key-s map key 'def key 'def ...)"
  (define-key-s keymap key-defs)
  )

;; * backward-kill-word-or-kill-region
(defun backward-kill-word-or-kill-region ()
  (interactive)
  (if mark-active
      (call-interactively 'kill-region)
    (call-interactively 'backward-kill-word)))

;; * toggle-comment-region
(defun toggle-comment-region (beg end &optional n)
  "Comment the lines in the region if the first non-blank line is
commented, and conversely, uncomment region. If optional prefix arg
N is non-nil, then for N positive, add N comment delimiters or for N
negative, remove N comment delimiters.
Uses `comment-region' which does not place comment delimiters on
blank lines."
  (interactive "r\nP")
  (if n
      (comment-region beg end (prefix-numeric-value n))
    (save-excursion
      (goto-char beg)
      (beginning-of-line)
      ;; skip blank lines
      (skip-chars-forward " \t\n")
      (if (looking-at (concat "[ \t]*\\(" (regexp-quote comment-start) "+\\)"))
          (uncomment-region beg end)
        (comment-region beg end)))))
